#!/usr/local/bin/perl -w
# SiteEngine.
# setup parameters.
# <c> Lesha, 2000
# all right reserved.
# opensource software; see artistic-license.txt for license agreement.
 
# edit this file after install.

{
$debug = 3;                             # debug level - for testing

# default values here - will be replaced after installation.
##### "to be replaced" block
$SITE_IP = "www.your.site.com/dir/to/your/site"; # the main site information 
if ($debug == 1) {
   $start_path=".";
}
else {
  $start_path="/absolute/file/path/to/your/files"; # absolute path to the files 
}

$email_command = "|/usr/lib/sendmail -t"; # sendmail command
$from_addr = "you\@domain.com";         # mail adress to send mails from.
$def_to_addr = "you\@domain.com";       # mail adress to send mails to.
                                        # by default.
##### end of "to be replaced" block

#<DO NOT TOUCH THIS LINE>

$data_dir = "des";                      # directory with description files
$static_dir = "static";                 # root description file - 
                                        # should exists at least empty

$authors_file =  "you.html";            # file with information about
                                        # the site authors.

$about_file = "your_company.html" ;     # file with information about site.
                                        # To add more static files change
                                        # &process_getfile() in index.cgi

$icons = "img";                         # directory to store image files.

#### logfiles ####
$logfile = "$start_path/$data_dir/mng_log.txt";         # admin actions log
$auth_log = "$start_path/$data_dir/auth_log.txt";       # authorisation log
$err_log = "$start_path/$data_dir/err_log.txt";         # error log
$install_log = "install_log.txt";                       # install log
$tarfile = "sengine.tar";
$tar_command = "/bin/tar xvf";


#### for management use ####


$need_def_news = 1;                     # allow everyone to add a "global" news
$def_news_field = "0";                  # defines a "number" of global news page
$def_news_sub = "";                     # defines a "sub" of global news page.

$fields_file = "fields.des";            # root description file
                                        # should exists at least empty

$field_dir_base = "$start_path/data";   # directory that keeps a data files
$css_dir = "css_dir";                   # directory for CSS files
$passwd_file = "$data_dir/users_pwd";   # if absent - 
                                        # will be created by first call.

$c_pwd_name = "cmnr";                   # name of cookie being used
$tmp_dir = "$start_path/tmp";          # directory for session files 
$gb_dir = "gb";                         # directory for guestbook files.
$front_page = "index.cgi";              # name of front page.
$mng_gb_present = 1;                    # need internal guestbook?
$show_act_log = 1;                      # need mng_log to be shown?
$show_act_log_count = 20;               # entries to show

$allow_change_pwd = 0;                  # if "1" - mng.cgi will display
                                        # password changing form.

#### misc globals ####
$superuser_mode = 0;                    # superuser by default?
$valid_user = 0;                        # has user sucessfully logged

$site_ip = $SITE_IP;
$contacts_fname = $authors_file;

$html_type = "HTML";                    # for graphical/text data upload 
$gr_type = "Graphics";                  # for graphical/text data upload 
$css_type = "CSS";                      # for graphical/text data upload 


#### messages ####
#
# (for localisation)
#
%MSG = (
'Error' => "Error:",
'Err_file' => "File operation problem",
'Err_1' => "Error. Please go back and correct your request.",
'Err_2' => "Please mail here if you have any questions",
'slogan' => "Life is never being so easy?",
'auth' => "About me",
'tree' => "Site map",
'search' => "Search",
'thanks' => "Thanks!",
'about' => "About site",
'opinion'=> "Leave your message",
'to_print'=> "Print",
'back'=>"<<",
'forth'=>">>",
'start'=>"Home",
'hello'=>"Hello, ",
'f_a'=>"Field added",
's_a'=>"Material added to field",
'add_s'=>"Add material",
'ch_s'=>"Sub-field changed",
'ch_s1'=>"at",
's_a1'=>"Material added ",
'ch_f'=>"Changed",
'sub_name' => "Material name:",
's_desc' => "Short Description:",
's_file' => "root file:",
'f_file' => "description file:",
'f_id' => "field ID number:",
'CSS' => "CSS file:",
's_pages' => "Pages:",
's_gb_name' => "Guestbook file name <br>(not active if empty - space to delete)<br>suggested to use the same name with field root file name.",
's_email' => "email to receive form output",
'gb_off' => "To NOT show guestbook at this page",
'news_on' => "Allow automatically upload news here",
'area' => "Here is a place to file that you're expecting to see in",
'f_back' => "Back to Field",
'pg'=>"Pages",
'ch_f'=>"Select field",
'ad_f'=>"Add field",
'ad_u'=>"Add user",
'brd_sent'=>"Sent",
'brd_r'=>"In reply to ",
'brd_s'=>"Subject",
'brd_c'=>"Comment",
'brd_rr'=>"Post",
'gb_name'=> "Name: <br>(must!)",
'gb_email'=> "E-mail:",
'gb_url'=> "Homepage:",
'gb_comment'=> "Comments:",
'gb_general'=> "Comments-Suggestions?",
'gb_town'=> "Location",
'gb_name_t'=> "Name:",
'gb_email_t'=> "E-mail:",
'gb_url_t'=>  "URL:",
'gb_comment_t'=>  "Comments?:",
'gb_general_t'=>  "???",
'gb_date_t'=>  "Date:",
'gb_town_t'=> "Location?:",
'gb_warn'=> "this field is required",
'mng_rep_1'=>  "Field added",
'mng_rep_2' =>  "Material(sub) added.",
'mng_rep_3' =>  "to field",
'mng_begin' =>  "begin",
'mng_out' =>  "See result",
'mng_logout' =>  "logout",
'mng_pwd' =>  "Do you want to change a password?",
'mng_field_name' =>  "Field name :",
'mng_bk_f' =>  "Back to field page",
'mng_add_news' =>  "Add \"news\"",
'mng_css' => "CSS file",
'tr_empty'=>"It is still empty.",
'tr_last'=>"last changes",
'tr_nope'=>"Empty",
'tr_comm'=>"Comments",
'tr_noname'=>"Noname",
'tr_thanx'=>"Thank you for voting!",
'tr_subj'=>"HERE IS A VOTE FROM YOUR SITE",
);


%MSG_r = (
'Error' => "a",
'Err_file' => "  ",
'Err_1' => "Error. Please go back and correct your request.",
'Err_1' => " .     .",
'Err_2' => "      ",
'slogan' => "      ?",
'auth' => " ",
'tree' => "  ",
'search' => "   ",
'thanks' => " !",
'about' => " O ?",
'opinion'=> "     :",
'to_print'=> "  ",
'back'=>" <",
'forth'=>" >",
'start'=>" ",
'hello'=>" ",
'f_a'=>"Field added",
's_a'=>"Material added to field",
'add_s'=>" l",
'ch_s'=>"  sub-",
'ch_s1'=>"  e",
's_a1'=>"  sub-",
'ch_f'=>"  ",
'sub_name' => "  :",
's_desc' => "  :",
's_file' => " K :",
'f_file' => "   ",
'f_id' => "field ID number:",
'CSS' => "  :",
's_pages' => "  :",
's_gb_name' => "  <br>(   )<br>     <br>       ",
's_email' => " email,    <br>  <br>(  )",
'gb_off' => "   ",
'news_on' => "    ",
'area' => "Here is a place to file that you're expecting to see in",
'f_back' => "   ",
'pg'=>" ",
'ch_f'=> "",
'ad_f'=>"  ",
'ad_u'=>"Add user",
'brd_sent'=>" ",
'brd_r'=>"   ",
'brd_s'=> "",
'brd_c'=>" ",
'brd_rr'=>"",
'gb_name'=> "  <font color=red>*</font>:",
'gb_email'=> "  e-mail:",
'gb_url'=> "   : ",
'gb_comment'=> "  :",
'gb_general'=> "  - ?",
'gb_town'=> "  ?:",
'gb_name_t'=> " :",
'gb_email_t'=> " e-mail:",
'gb_url_t'=>  "  :",
'gb_comment_t'=>  " :",
'gb_general_t'=>  "  - ?",
'gb_date_t'=>  " :",
'gb_town_t'=> " :",
'gb_warn'=> "    ",
'mng_rep_1'=>   " ",
 'mng_rep_2' =>  "",
'mng_rep_3' =>  "  ",
'mng_begin' =>  "begin",
'mng_out' =>  "See result",
'mng_logout' =>  "logout",
'mng_pwd' =>  "   ?",
'mng_field_name' =>  "  :",
'mng_bk_f' =>  "   ",
'mng_add_news' =>  "  \"\"",
'mng_css' => "  ? (CSS)",
'tr_empty'=>" It is still empty -<br>    .",
'tr_last'=>"   ",
'tr_nope'=>" ",
'tr_comm'=>" Comments",
'tr_noname'=>"  ",
'tr_thanx'=>"       !",
'tr_subj'=> " !",

);

################ include files: 
if ($debug == 1) {
require "lib/tools.cgi";                    # main tools - cookies, login, etc.
require "lib/html.cgi";                     # site design consts - 
                                        # change it to change colors, 
                                        # fonts, etc. 

require "lib/gb.cgi";                       # guestbook tools
require "lib/tree.cgi";                     # traversing site tools
require "lib/brd.cgi";                      # webboard tools.
}



'success';
}


