#!/usr/local/bin/perl -w
# web installation of SiteEngine goes here.
# <c> Lesha, 2000
# all right reserved.
# opensource software; see artistic-license.txt for license agreement.
 
require "s.pl";

print "Content-type: text/html\n\n";

&decode_vars;

if ($FORM{'act'} =~ /setup/i) {
   &do_setup;
   &print_results;
}

&show_form;
exit 0;

###########################################################################
sub do_setup {
###########################################################################
  my $p = oct("0755");

  if ($FORM{'SITE_IP'}) {
     $SITE_IP  = $FORM{'SITE_IP'}; 
  }
  if ($FORM{'start_path'}) {
     $start_path = $FORM{'start_path'}; 
  }
  if ($FORM{'email_command'}) {
     $email_command = $FORM{'email_command'}; 
  }
  if ($FORM{'from_addr'}) {
     $from_addr = $FORM{'from_addr'}; 
  }
  if ($FORM{'def_to_addr'}) {
     $def_to_addr =$FORM{'def_to_addr'}; 
  }

  if (-d $start_path ) {
    &make_directories;
  }
  else {
    &error ("bad start directory: ", "connot install.");
  }

  &put_values_to_setup;
  &write_log ("file updated: $start_path/s.pl");

  system("cp $tarfile $start_path") ;
  &write_log ("cp $tarfile $start_path");
  
  chdir "$start_path" or &error ("Can't cd to $start_path: $!");
  &write_log ("chdir $start_path");

  print "<pre>";
  system("$tar_command $start_path/$tarfile");
  print "</pre>";
  &write_log ("$tar_command $start_path/$tarfile >& $install_log");
  
  $cp1 = "cp brd.cgi gb.cgi html.cgi  tree.cgi tools.cgi lib";
  system("$cp1");
  &write_log ("$cp1");
   
  $cp2 = "cp htaccess .htaccess";
  system("$cp2");
  &write_log ("$cp2");

  $cp3 = "cp form_example.html news_example.html board_example.html examples";
  system("$cp3");
  &write_log ("$cp3");

  $cp4 = "cp fields.des des";
  system("$cp4");
  &write_log ("$cp4");

  chmod($p, "mng.cgi") ||
             &error ("Can't chmod($p, mng.cgi) : $!");
  &write_log ("chmod(0655, mng.cgi");

  chmod($p, "index.cgi") ||
             &error ("Can't chmod($p, index.cgi) : $!");
  &write_log ("chmod(0655, mng.cgi");

  $rm1 = "rm -f brd.cgi gb.cgi html.cgi tree.cgi tools.cgi fields.des htaccess form_example.html news_example.html board_example.html sengine.tar";
  system("$rm1");
  &write_log ("$cp2");

}

###########################################################################
sub make_directories {
###########################################################################
  my $permissions = oct("0755");

  mkdir("$start_path/data", $permissions) || 
                                 &error ("cannot create directory: ", "$!");
  &write_log ("Directory created: $start_path/data");

  mkdir("$start_path/$data_dir", $permissions) ||
                                 &error ("cannot create directory: ", "$!");
  &write_log ("Directory created: $start_path/$data_dir");

  mkdir("$start_path/$css_dir", $permissions) ||
                                  &error ("cannot create directory: ", "$!");
  &write_log ("Directory created: $start_path/$css_dir");

  mkdir("$start_path/$icons", $permissions) || 
                                 &error ("cannot create directory: ", "$!");
  &write_log ("Directory created: $start_path/$icons");

  mkdir("$start_path/data/$static_dir", $permissions) || 
                                  &error ("cannot create directory: ", "$!");  
  &write_log ("Directory created: $start_path/data/$static_dir");
 
  mkdir("$start_path/tmp", $permissions) || 
                 &error ("cannot create directory: $start_path/tmp", "$!");  
  &write_log ("Directory created: $start_path/tmp ");

  mkdir("$start_path/lib", $permissions) || 
                &error ("cannot create directory: $start_path/lib", "$!");  
  &write_log ("Directory created: $start_path/lib");

  mkdir("$start_path/examples", $permissions) || 
              &error ("cannot create directory: $start_path/examples ", "$!");  
  &write_log ("Directory created: $start_path/examples");
} 

###########################################################################
sub write_log {
###########################################################################
  local($text);

  $text = $_[0];

  if ($logfile eq '') {return};

  open (LOG,">>$start_path/$install_log");
  print LOG "$text\n";
  close (LOG);
}

###########################################################################
sub print_results {
###########################################################################
  print "<hr>\n<pre>";
  open (LIC,"artistic-license.txt");
  while (<LIC>) {print;}
  close (LIC);
 
  
  print "</pre><p><strong>Now please follow this<br>
         <a href=http://$SITE_IP/login.html>link</a> and use any 
         login and password you wish - it will be saved as 
         administrator's!</strong>";
  exit;
}

###########################################################################
sub error {
###########################################################################
my   $msg1 = $_[0];
my   $msg = $_[1];

$head =<<HTML;
Content-type: text/html


<html>
<head><title>Error: $msg1</title></head>
<body>
<strong>
$msg1 : $msg<br>
</strong><br><hr><br>
</body>
</html>
HTML

   print $head;
   exit 0;
}

###########################################################################
sub show_form {
###########################################################################
   print <<HTML;
Content-type: text/html


<html>
<head><title>web installation of SiteEngine goes here.</title></head>
<body>
<p>

<center>Please, fill up the form and press "OK" to install <a href=http://sourceforge.net/projects/sengine/>SiteEngine</a>.<br>
<strong>Please do not press "OK" button twice!</strong>
<p>

<form><INPUT TYPE=hidden NAME=act VALUE=setup>

<table>
<tr><th>SITE IP:</th>
<td><input name=SITE_IP value=$ENV{'SERVER_NAME'}></td>
</tr>

<tr><th>START PATH:</th>
<td><input name=start_path value=$start_path></td>
</tr>

<tr><th>Default email address to send mails FROM:</th>
<td><input name=from_addr value=$from_addr></td>
</tr>

<tr><th>Default email address to send mails TO:</th>
<td><input name=def_to_addr  value=$def_to_addr></td>
</tr>

<tr><th>SENDMAIL command:</th>
<td><input name=email_command value="$email_command"></td>
</tr>
</table>

<INPUT TYPE=submit value=OK> <INPUT TYPE=reset> 
</form>
</center>

<p><hr><br>
Please, contact <a href=mailto:lesha\@yahoo.com>Me</a> - I''ll do my best to help you.

</body>
</html>
HTML
}

###########################################################################
sub decode_vars {
###########################################################################
$all_input = '';

  read (STDIN, $all_input, $ENV{'CONTENT_LENGTH'});

  if ($ENV{'QUERY_STRING'}) {
     $all_input = "$all_input\&$ENV{'QUERY_STRING'}";
  }
  @pairs=split(/&/,$all_input);

  foreach $item(@pairs)
  {
    ($key,$content)=split(/=/,$item,2);

    $content=~tr/+/ /;
    $content=~s/%(..)/pack("c",hex($1))/ge;

    $content=~s/\012//gs;
    $content=~s/\015/ /gs;
    $content=~s/'//gs;
    $content=~s/"//gs;
    $content=~s/`//gs;
    $content=~s/<//gs;
    $content=~s/>//gs;
    $content=~s/{//gs;
    $content=~s/}//gs;
    $content=~s/\[//gs;
    $content=~s/\]//gs;
    $content=~s/\;//gs;
    $content=~s/\.//gs;
    $content=~s/&gt\;//gs;
    $content=~s/&lt\;//gs;
    $content=~s/&quot\;//gs;

    $FORM{$key}=$content;
  }
}

###########################################################################
sub  put_values_to_setup{
###########################################################################
  my $magic_line = "<DO NOT TOUCH THIS LINE>";
  my $data_blck = <<END;
  \$SITE_IP  = \"$SITE_IP\";
  \$start_path = "$start_path\" ;
  \$email_command = \"$email_command\" ;
  \$from_addr = \'$from_addr\';
  \$def_to_addr =\'$def_to_addr\'; 
  \$debug \= 1;
END

  open (F, "s.pl") || &error ("cannot open s.pl to read");
  @file_data =  <F>;
  close F;

  foreach $line (@file_data) {     
    push @file_res, $line;
    $hint = grep (/$magic_line/i, $line);
    if ($hint) {
       push @file_res, $data_blck;
    }
  }
 
  open (F, ">/$start_path/s.pl") ||  &error ("cannot open s.pl to update");
  foreach $line  (@file_res) {print F $line;}
  close F;
}

